Scriptname BCP_ItemAddedScript extends ReferenceAlias  

ReferenceAlias Property playerRef Auto
bool functionBusy = False

FormList Property BCP_CraftedPotionsFormList Auto

Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	bool debugVerbosity = (playerRef as BCP_MainScript).debugVerbosity
	Debug.TraceConditional(self + " Item added, base item:  " + akBaseItem + " item ref: " + akItemReference + "source container: " + akSourceContainer, debugVerbosity)
	Potion craftedPotion = akBaseItem as Potion
	While functionBusy
		Utility.Wait(0.6)
		Debug.TraceConditional(self + "Function busy, waiting", debugVerbosity)
	EndWhile
	functionBusy = True
		If craftedPotion && !craftedPotion.IsFood()
			Debug.TraceConditional(self + " Item is a potion.", debugVerbosity)
			If !BCP_CraftedPotionsFormList.HasForm(craftedPotion)
				Debug.TraceConditional(self + " Item is a new crafted potion, calling NewPotionCrafted function.", debugVerbosity)
				(playerRef as BCP_MainScript).NewPotionCrafted(craftedPotion)
			Else
				Debug.TraceConditional(self + " Potion already known", debugVerbosity)
				(playerRef as BCP_MainScript).KnownPotionCrafted(craftedPotion)
			EndIf
		Else
			Debug.TraceConditional(self + " Item crafted, not a potion.", debugVerbosity)
		EndIf
	functionBusy = False
EndEvent
