Scriptname BCP_MCMScript extends SKI_ConfigBase  


ReferenceAlias Property playerRef Auto

GlobalVariable Property BCP_MatchModelGV Auto
GlobalVariable Property BCP_MatchNameGV Auto
GlobalVariable Property BCP_EffectsInNameGV Auto
GlobalVariable Property BCP_EffectsAbbreviationGV Auto
GlobalVariable Property BCP_BrewedSuffixGV Auto
GlobalVariable Property BCP_MixedSuffixGV Auto
GlobalVariable Property BCP_ImpureSuffixGV Auto
GlobalVariable Property BCP_NameTrimmingGV Auto
GlobalVariable Property BCP_MaxNameLengthGV Auto
GlobalVariable Property BCP_CalculateImpureGoldGV Auto
GlobalVariable Property BCP_CalculateXPGV Auto

GlobalVariable Property BCP_MaxSavedPotionsGV Auto
GlobalVariable Property BCP_RecalculateGV Auto
GlobalVariable Property BCP_ResetGV Auto



Bool bMatchModel
Bool bMatchName
Bool bEffectsInName
Bool beffectsAbbreviation
Bool bBrewedSuffix
Bool bMixedSuffix
Bool bImpureSuffix
Bool bNameTrimming
Int iMaxNameLength
Bool bCalculateImpureGold
Bool bCalculateXP

Int iMaxSavedPotions
Bool bRecalculate
Bool bReset
Bool bLogging


Int iMatchModelOption
Int iMatchNameOption
Int iEffectsInNameOption
Int ieffectsAbbreviationOption
Int iBrewedSuffixOption
Int iMixedSuffixOption
Int iImpureSuffixOption
Int iNameTrimmingOption
Int iMaxNameLengthOption
Int iCalculateImpureGoldOption
Int iCalculateXPOption

Int iMaxSavedPotionsOption
Int iRecalculateOption
Int iResetOption
Int iLoggingOption

int trimFlag
int abvrFlag
int goldFlag



Event OnConfigInit()
	Pages = new string[2]
	Pages[0] = "Settings"
	Pages[1] = "Advanced Settings"
	
	bMatchModel = BCP_MatchModelGV.GetValue() == 1.0
	bMatchName = BCP_MatchNameGV.GetValue() == 1.0
	bEffectsInName = BCP_EffectsInNameGV.GetValue() == 1.0
	beffectsAbbreviation = BCP_EffectsAbbreviationGV.GetValue() == 1.0
	bBrewedSuffix = BCP_BrewedSuffixGV.GetValue() == 1.0
	bMixedSuffix = BCP_MixedSuffixGV.GetValue() == 1.0
	bImpureSuffix = BCP_ImpureSuffixGV.GetValue() == 1.0
	bNameTrimming = BCP_NameTrimmingGV.GetValue() == 1.0
	iMaxNameLength = BCP_MaxNameLengthGV.GetValue() as int
	bCalculateImpureGold = BCP_CalculateImpureGoldGV.GetValue() == 1.0
	bCalculateXP = BCP_CalculateXPGV.GetValue() == 1.0
	
	iMaxSavedPotions = BCP_MaxSavedPotionsGV.GetValue() as int
	bRecalculate = BCP_RecalculateGV.GetValue() == 1.0
	bReset = BCP_ResetGV.GetValue() == 1.0
	bLogging = (playerRef as BCP_MainScript).debugVerbosity
EndEvent



Event OnPageReset(string currentPage)

	If (currentPage == "")
		LoadCustomContent("BCP/MCMCover.dds", 80, 0)
		return
	Else
		UnloadCustomContent()
	EndIf

	If (currentPage == "Settings")
		SetCursorFillMode(TOP_TO_BOTTOM)
		
		AddHeaderOption("Potion Matching")
		iMatchModelOption = AddToggleOption("Match model", bMatchModel)
		iMatchNameOption = AddToggleOption("Match name", bMatchName)
		AddEmptyOption()
		
		AddHeaderOption("Potion Names")
		iEffectsInNameOption = AddToggleOption("Effects in name", bEffectsInName)
		If bEffectsInName
			abvrFlag = OPTION_FLAG_NONE
		Else
			abvrFlag = OPTION_FLAG_DISABLED
		EndIf
		ieffectsAbbreviationOption = AddToggleOption("Abbreviate effects names", beffectsAbbreviation, abvrFlag)
		iBrewedSuffixOption = AddToggleOption("Brewed suffix", bBrewedSuffix)
		iMixedSuffixOption = AddToggleOption("Mixed suffix", bMixedSuffix)
		iImpureSuffixOption = AddToggleOption("Impure suffix", bImpureSuffix)
		iNameTrimmingOption = AddToggleOption("Trim long names", bNameTrimming)
		If bNameTrimming
			trimFlag = OPTION_FLAG_NONE
		Else
			trimFlag = OPTION_FLAG_DISABLED
		EndIf
		iMaxNameLengthOption = AddSliderOption("Max name length", iMaxNameLength, "{0} characters", trimFlag)
		AddEmptyOption()
		
		AddHeaderOption("Impure Potions Gold Value")
		iCalculateImpureGoldOption = AddToggleOption("Impure potions value malus", bCalculateImpureGold)
		If bCalculateImpureGold
			goldFlag = OPTION_FLAG_NONE
		Else
			goldFlag = OPTION_FLAG_DISABLED
		EndIf
		iCalculateXPOption = AddToggleOption("Calculate XP", bCalculateXP, goldFlag)
		
	ElseIf (currentPage == "Advanced Settings")
		SetCursorFillMode(TOP_TO_BOTTOM)
		bRecalculate = BCP_RecalculateGV.GetValue() == 1.0
		bReset = BCP_ResetGV.GetValue() == 1.0
		
		iMaxSavedPotionsOption = AddSliderOption("Max saved potions", iMaxSavedPotions, "{0} potions")
		iRecalculateOption = AddToggleOption("Re-calculate", bRecalculate)
		iResetOption = AddToggleOption("Erase data", bReset)
		iLoggingOption = AddToggleOption("Logging", bLogging)
	EndIf
	
EndEvent


Event OnOptionSelect(int optionSelected)

	If optionSelected == iMatchModelOption
		bMatchModel = !bMatchModel
		SetToggleOptionValue(optionSelected, bMatchModel)
		If bMatchModel
			BCP_MatchModelGV.SetValue(1.0)
		Else
			BCP_MatchModelGV.SetValue(0.0)
		EndIf
	ElseIf optionSelected == iMatchNameOption
		bMatchName = !bMatchName
		SetToggleOptionValue(optionSelected, bMatchName)
		If bMatchName
			BCP_MatchNameGV.SetValue(1.0)
		Else
			BCP_MatchNameGV.SetValue(0.0)
		EndIf
	ElseIf optionSelected == iEffectsInNameOption
		bEffectsInName = !bEffectsInName
		SetToggleOptionValue(optionSelected, bEffectsInName)
		If bEffectsInName
			SetOptionFlags(ieffectsAbbreviationOption, OPTION_FLAG_NONE)
			BCP_EffectsInNameGV.SetValue(1.0)
		Else
			SetOptionFlags(ieffectsAbbreviationOption, OPTION_FLAG_DISABLED)
			BCP_EffectsInNameGV.SetValue(0.0)
		EndIf
	ElseIf optionSelected == ieffectsAbbreviationOption
		beffectsAbbreviation = !beffectsAbbreviation
		SetToggleOptionValue(optionSelected, beffectsAbbreviation)
		If beffectsAbbreviation
			BCP_EffectsAbbreviationGV.SetValue(1.0)
		Else
			BCP_EffectsAbbreviationGV.SetValue(0.0)
		EndIf
	ElseIf optionSelected == iBrewedSuffixOption
		bBrewedSuffix = !bBrewedSuffix
		SetToggleOptionValue(optionSelected, bBrewedSuffix)
		If bBrewedSuffix
			BCP_BrewedSuffixGV.SetValue(1.0)
		Else
			BCP_BrewedSuffixGV.SetValue(0.0)
		EndIf
	ElseIf optionSelected == iMixedSuffixOption
		bMixedSuffix = !bMixedSuffix
		SetToggleOptionValue(optionSelected, bMixedSuffix)
		If bMixedSuffix
			BCP_MixedSuffixGV.SetValue(1.0)
		Else
			BCP_MixedSuffixGV.SetValue(0.0)
		EndIf
	ElseIf optionSelected == iImpureSuffixOption
		bImpureSuffix = !bImpureSuffix
		SetToggleOptionValue(optionSelected, bImpureSuffix)
		If bImpureSuffix
			BCP_ImpureSuffixGV.SetValue(1.0)
		Else
			BCP_ImpureSuffixGV.SetValue(0.0)
		EndIf
	ElseIf optionSelected == iNameTrimmingOption
		bNameTrimming = !bNameTrimming
		SetToggleOptionValue(optionSelected, bNameTrimming)
		If bNameTrimming
			SetOptionFlags(iMaxNameLengthOption, OPTION_FLAG_NONE)
			BCP_NameTrimmingGV.SetValue(1.0)
		Else
			SetOptionFlags(iMaxNameLengthOption, OPTION_FLAG_DISABLED)
			BCP_NameTrimmingGV.SetValue(0.0)
		EndIf
	ElseIf optionSelected == iCalculateImpureGoldOption
		bCalculateImpureGold = !bCalculateImpureGold
		SetToggleOptionValue(optionSelected, bCalculateImpureGold)
		If bCalculateImpureGold
			SetOptionFlags(iCalculateXPOption, OPTION_FLAG_NONE)
			BCP_CalculateImpureGoldGV.SetValue(1.0)
		Else
			SetOptionFlags(iCalculateXPOption, OPTION_FLAG_DISABLED)
			BCP_CalculateImpureGoldGV.SetValue(0.0)
		EndIf
	ElseIf optionSelected == iCalculateXPOption
		bCalculateXP = !bCalculateXP
		SetToggleOptionValue(optionSelected, bCalculateXP)
		If bCalculateXP
			BCP_CalculateXPGV.SetValue(1.0)
		Else
			BCP_CalculateXPGV.SetValue(0.0)
		EndIf
		
	ElseIf optionSelected == iRecalculateOption
		bRecalculate = !bRecalculate
		SetToggleOptionValue(optionSelected, bRecalculate)
		If bRecalculate
			BCP_RecalculateGV.SetValue(1.0)
		Else
			BCP_RecalculateGV.SetValue(0.0)
		EndIf
	ElseIf optionSelected == iResetOption
		bReset = !bReset
		SetToggleOptionValue(optionSelected, bReset)
		If bReset
			BCP_ResetGV.SetValue(1.0)
		Else
			BCP_ResetGV.SetValue(0.0)
		EndIf
	ElseIf optionSelected == iLoggingOption
		bLogging = !bLogging
		SetToggleOptionValue(optionSelected, bLogging)
		(playerRef as BCP_MainScript).debugVerbosity = bLogging
	EndIf
	
EndEvent



Event OnOptionSliderOpen(int optionSelected)
	If (optionSelected == iMaxNameLengthOption)
		SetSliderDialogStartValue(iMaxNameLength)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(30, 100)
		SetSliderDialogInterval(1)
	ElseIf (optionSelected == iMaxSavedPotionsOption)
		SetSliderDialogStartValue(iMaxSavedPotions)
		SetSliderDialogDefaultValue(40.0)
		SetSliderDialogRange(10, 100)
		SetSliderDialogInterval(1)
	endIf
EndEvent


Event OnOptionSliderAccept(int optionSelected, float newValue)
	If (optionSelected == iMaxNameLengthOption)
		iMaxNameLength = newValue as int
		SetSliderOptionValue(iMaxNameLengthOption, iMaxNameLength, "{0} characters")
		BCP_MaxNameLengthGV.SetValue(iMaxNameLength)
	ElseIf (optionSelected == iMaxSavedPotionsOption)
		iMaxSavedPotions = newValue as int
		SetSliderOptionValue(iMaxSavedPotionsOption, iMaxSavedPotions, "{0} potions")
		BCP_MaxSavedPotionsGV.SetValue(iMaxSavedPotions)
	EndIf
EndEvent


Event OnOptionHighlight(int selectedOption)

	If (selectedOption == iMatchModelOption)
		SetInfoText("If toggled on when you craft a potion, its appearance will be copied from the best matching generic potion.")
	ElseIf (selectedOption == iMatchNameOption)
		SetInfoText("If toggled on when you craft a potion, its name will be copied from the best matching generic potion.")
	ElseIf (selectedOption == iEffectsInNameOption)
		SetInfoText("If toggled on when you craft a multi-effects potion, its effects will be listed in its name.")
	ElseIf (selectedOption == ieffectsAbbreviationOption)
		SetInfoText("If toggled, effects names from the option above will be abbreviated to try to prevent potions names from being too long.")
	ElseIf (selectedOption == iBrewedSuffixOption)
		SetInfoText("If toggled on when you craft a potion, its name will have start with \"Brewed\".")
	ElseIf (selectedOption == iMixedSuffixOption)
		SetInfoText("If toggled on when you craft a multi-effects pure potion, its name will have start with \"Mixed\".")
	ElseIf (selectedOption == iImpureSuffixOption)
		SetInfoText("If toggled on when you craft a multi-effects impure potion, its name will have start with \"Impure\".")
	ElseIf (selectedOption == iNameTrimmingOption)
		SetInfoText("If toggle on, crafted potions names will not be longer than the value set by the \"Max name length\" option.")
	ElseIf (selectedOption == iMaxNameLengthOption)
		SetInfoText("Maximum name length if the \"Trim long names\" option is toggled on.")
	ElseIf (selectedOption == iCalculateImpureGoldOption)
		SetInfoText("If toggle on, impure potions will have their gold value calculated by subtracting unwanted effects values from wanted effects values instead of just adding them.")
	ElseIf (selectedOption == iCalculateXPOption)
		SetInfoText("Alchemy Experience gain depends on the value of the potions you craft. If you toggle this option on, the mod will calculate itself the alchemy experience gained and impure potions will give you less experience. All the experience gained will be added when you leave the alchemy table. If toggled off, the vanilla XP system is used and impure potion will give you XP like in vanilla even if their gold value is lowered.")
	ElseIf (selectedOption == iMaxSavedPotionsOption)
		SetInfoText("Maximum number of different potions saved. Be careful of script load during save load if you up this value.")
	ElseIf (selectedOption == iRecalculateOption)
		SetInfoText("If toggled on when a save is loaded, every saved crafted potion will have its values re-calculated and updated. When doing this, loading from desktop is preferable.")
	ElseIf (selectedOption == iResetOption)
		SetInfoText("If toggled on when a save is loaded, every saved data will be erased. When doing this, loading from desktop is preferable.")
	ElseIf (selectedOption == iLoggingOption)
		SetInfoText("If toggle on, enables papyrus logging.")		
	EndIf
	
EndEvent
